/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGBATTLE_TURNARENA
#define SIGBATTLE_TURNARENA

// Sigbattle includes
#include "Arena.h"
#include "TeamMember.h"

// Qt includes
#include <QtCore/QFutureWatcher>

// Forward declarations
class QTimer;

namespace Sigbattle
{
class SIGBATTLE_EXPORT TurnArena : public Arena
{
    Q_OBJECT
    
    public:
        TurnArena(Sigscript::SigmodWrapper* sigmod, QList<Player*> players, const bool isWild, QObject* parent);
    signals:
        void roundAboutToStart();
        void roundStart();
        void roundAboutToEnd();
        void roundEnd();
    public slots:
    protected slots:
        void processRound();
    protected:
        void setupBattle();
    private:
        QFutureWatcher<TeamMember::RequestedAction>* m_watcher;
        QTimer* m_timer;
};

bool sortActions(const TeamMember::RequestedAction& reqAction1, const TeamMember::RequestedAction& reqAction2);

}
Q_DECLARE_METATYPE(Sigbattle::TurnArena*)

#endif
