/*
 * Copyright 2007-2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMOD_SPECIESITEM
#define SIGMOD_SPECIESITEM

// Sigmod includes
#include "Object.h"

namespace Sigmod
{
// Forward declarations
class Species;

class SIGMOD_EXPORT SpeciesItem : public Object
{
    Q_OBJECT
    
    public:
        SpeciesItem(const SpeciesItem& item);
        SpeciesItem(const Species* parent, const int id);
        SpeciesItem(const SpeciesItem& item, const Species* parent, const int id);
        SpeciesItem(const QDomElement& xml, const Species* parent, const int id = -1);
        
        void validate();
        
        void load(const QDomElement& xml);
        QDomElement save() const;
        
        void setItem(const int item);
        void setWeight(const int weight);
        
        int item() const;
        int weight() const;
        
        SpeciesItem& operator=(const SpeciesItem& rhs);
    private:
        int m_item;
        int m_weight;
};
}

#endif
