/*
 * Copyright 2007-2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMOD_STORE
#define SIGMOD_STORE

// Sigmod includes
#include "Object.h"

// Qt includes
#include <QtCore/QList>

namespace Sigmod
{
// Forward declarations
class Sigmod;

class SIGMOD_EXPORT Store : public Object
{
    Q_OBJECT
    
    public:
        Store(const Store& store);
        Store(const Sigmod* parent, const int id);
        Store(const Store& store, const Sigmod* parent, const int id);
        Store(const QDomElement& xml, const Sigmod* parent, const int id = -1);
        
        void validate();
        
        void load(const QDomElement& xml);
        QDomElement save() const;
        
        void setName(const QString& name);
        void setItem(const int item, const bool state);
        
        QString name() const;
        bool item(const int item) const;
        QList<int> items() const;
        
        Store& operator=(const Store& rhs);
    private:
        QString m_name;
        QList<int> m_item;
};
}

#endif
