/*
 * Copyright 2007-2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMOD_TYPE
#define SIGMOD_TYPE

// Sigmod includes
#include "Fraction.h"
#include "Object.h"

namespace Sigmod
{
// Forward declarations
class Sigmod;

class SIGMOD_EXPORT Type : public Object
{
    Q_OBJECT
    
    public:
        Type(const Type& type);
        Type(const Sigmod* parent, const int id);
        Type(const Type& type, const Sigmod* parent, const int id);
        Type(const QDomElement& xml, const Sigmod* parent, const int id = -1);
        
        void validate();
        
        void load(const QDomElement& xml);
        QDomElement save() const;
        
        void setName(const QString& name);
        void setStab(const Fraction& stab);
        
        QString name() const;
        Fraction stab() const;
        
        Type& operator=(const Type& rhs);
    private:
        QString m_name;
        Fraction m_stab;
};
}

#endif
