/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_BADGEUI
#define SIGMODR_BADGEUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_badge.h"

// Forward declarations
namespace Sigmod
{
class Badge;
}

namespace Sigmodr
{
class BadgeUI : public ObjectUI, private Ui::formBadge
{
    Q_OBJECT
    
    public:
        BadgeUI(Sigmod::Badge* badge, QWidget* parent);
        ~BadgeUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varName_textChanged(const QString& name);
        void on_varObey_valueChanged(const int obey);
        void on_varFace_currentIndexChanged(const int face);
        void on_varBadge_currentIndexChanged(const int badge);
        void on_varStatMultiplier_valueChanged(const Sigmod::Fraction& multiplier);
    private slots:
        void initGui();
        void refreshGui();
        void setGui();
};
}

#endif
