/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "CoinListUI.h"

// Sigmod includes
#include "../sigmod/CoinList.h"
#include "../sigmod/Sigmod.h"

Sigmodr::CoinListUI::CoinListUI(Sigmod::CoinList* coinList, QWidget* parent) :
        ObjectUI(parent)
{
    setupUi(this);
    setObjects(coinList, new Sigmod::CoinList(*coinList));
}

Sigmodr::CoinListUI::~CoinListUI()
{
}

void Sigmodr::CoinListUI::setGui()
{
    varName->setText(qobject_cast<Sigmod::CoinList*>(modified())->name());
    varScript->setValue(qobject_cast<Sigmod::CoinList*>(modified())->script());
}

void Sigmodr::CoinListUI::apply()
{
    *qobject_cast<Sigmod::CoinList*>(original()) = *qobject_cast<Sigmod::CoinList*>(modified());
    emit(changed(false));
}

void Sigmodr::CoinListUI::discard()
{
    *qobject_cast<Sigmod::CoinList*>(modified()) = *qobject_cast<Sigmod::CoinList*>(original());
    setGui();
    emit(changed(false));
}

void Sigmodr::CoinListUI::on_varName_textChanged(const QString& name)
{
    const int cursor = varName->cursorPosition();
    qobject_cast<Sigmod::CoinList*>(modified())->setName(name);
    varName->setCursorPosition(cursor);
}

void Sigmodr::CoinListUI::on_varScript_valueChanged(const Sigmod::Script& script)
{
    qobject_cast<Sigmod::CoinList*>(modified())->setScript(script);
}
