/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_ITEMTYPEUI
#define SIGMODR_ITEMTYPEUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_itemtype.h"

// Forward declarations
namespace Sigmod
{
class ItemType;
}

namespace Sigmodr
{
class ItemTypeUI : public ObjectUI, private Ui::formItemType
{
    Q_OBJECT
    
    public:
        ItemTypeUI(Sigmod::ItemType* itemType, QWidget* parent);
        ~ItemTypeUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varName_textChanged(const QString& name);
        void on_varComputer_valueChanged(const int computer);
        void on_varPlayer_valueChanged(const int player);
        void on_varCount_currentIndexChanged(const int count);
    private slots:
        void initGui();
        void setGui();
};
}

#endif
