/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_MAPUI
#define SIGMODR_MAPUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_map.h"

// Forward declarations
namespace Sigmod
{
class Map;
}
namespace Sigmodr
{
class TilemapModel;
class TileDelegate;

class MapUI : public ObjectUI, private Ui::formMap
{
    Q_OBJECT
    
    public:
        MapUI(Sigmod::Map* map, QWidget* parent);
        ~MapUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varName_textChanged(const QString& name);
        void on_boxFlyWarp_toggled();
        void on_varFlyWarp_activated(const int flyWarp);
        void on_varType_activated(const int type);
        void on_varTilemap_clicked(const QModelIndex& index);
        void on_buttonAddColumn_pressed();
        void on_buttonAddRow_pressed();
        void on_buttonDeleteColumn_pressed();
        void on_buttonDeleteRow_pressed();
        void on_buttonInsertColumn_pressed();
        void on_buttonInsertRow_pressed();
        void on_varTile_activated(const int tile);
    private slots:
        void initGui();
        void refreshGui();
        void setGui();
    private:
        QModelIndex m_index;
};
}

#endif
