/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_MAPWARPUI
#define SIGMODR_MAPWARPUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_mapwarp.h"

// Forward declarations
namespace Sigmod
{
class MapWarp;
}

namespace Sigmodr
{
class MapWarpUI : public ObjectUI, private Ui::formMapWarp
{
    Q_OBJECT
    
    public:
        MapWarpUI(Sigmod::MapWarp* warp, QWidget* parent);
        ~MapWarpUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varName_textChanged(const QString& name);
        void on_varCoordinate_valueChanged(const QPoint& coordinate);
        void on_varType_activated(const int type);
        void on_varToMap_activated(const int toMap);
        void on_varToWarp_activated(const int toWarp);
        void on_varScript_valueChanged(const Sigmod::Script& script);
    private slots:
        void initGui();
        void refreshGui();
        void setGui();
    private:
        int m_lastMap;
};
}

#endif
