/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_MOVEUI
#define SIGMODR_MOVEUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_move.h"

// Forward declarations
namespace Sigmod
{
class Move;
}

namespace Sigmodr
{
class MoveUI : public ObjectUI, private Ui::formMove
{
    Q_OBJECT
    
    public:
        MoveUI(Sigmod::Move* move, QWidget* parent);
        ~MoveUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varName_textChanged(const QString& name);
        void on_varPriority_valueChanged(const int priority);
        void on_varAccuracy_valueChanged(const Sigmod::Fraction& accuracy);
        void on_varPower_valueChanged(const int power);
        void on_varType_activated(const int type);
        void on_varPowerPoints_valueChanged(const int powerPoints);
        void on_varSpecial_toggled(const bool special);
        void on_varDescription_textChanged(const QString& description);
        void on_varBattleScript_valueChanged(const Sigmod::Script& battleScript);
        void on_varWorldScript_valueChanged(const Sigmod::Script& worldScript);
        void on_varPriorityScript_valueChanged(const Sigmod::Script& priorityScript);
    private slots:
        void refreshGui();
        void setGui();
};
}

#endif
