/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_POINTWIDGET
#define SIGMODR_POINTWIDGET

// Qt includes
#include <QtCore/QPoint>
#include <QtGui/QWidget>

// Form include
#include "ui_point.h"

namespace Sigmodr
{
class PointWidget : public QWidget, private Ui::formPoint
{
    Q_OBJECT
    
    public:
        explicit PointWidget(QWidget* parent, const QPoint& value = QPoint(0, 0));
        
        QPoint value() const;
    signals:
        void valueChanged(const QPoint&);
    public slots:
        void setValue(const QPoint& value);
        void setMaximum(const QPoint& maximum);
    protected slots:
        void on_varX_valueChanged(const int x);
        void on_varY_valueChanged(const int y);
    private:
        QPoint m_value;
};
}

#endif
