/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_SIGMODUI
#define SIGMODR_SIGMODUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_sigmod.h"

// Forward declarations
namespace Sigmod
{
class Sigmod;
}

namespace Sigmodr
{
class SigmodUI : public ObjectUI, private Ui::formSigmod
{
    Q_OBJECT
    
    public:
        SigmodUI(Sigmod::Sigmod* sigmod, QWidget* parent);
        ~SigmodUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varTitle_textChanged(const QString& title);
        void on_varVersion_textChanged(const QString& version);
        void on_varDescription_textChanged(const QString& description);
        void on_varMap_activated(const int map);
        void on_varWarp_activated(const int warp);
        void on_varTypechart_clicked(const QModelIndex& index);
        void on_varEffectiveness_valueChanged(const Sigmod::Fraction& multiplier);
    private slots:
        void initGui();
        void refreshGui();
        void setGui();
    private:
        bool m_changingMult;
        int m_lastMap;
        QModelIndex m_index;
};
}

#endif
