/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_SOUNDUI
#define SIGMODR_SOUNFUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_sound.h"

// Forward declarations
class QBuffer;
namespace Sigmod
{
class Sound;
}
namespace Phonon
{
class AudioOutput;
class MediaObject;
}

namespace Sigmodr
{
class SoundUI : public ObjectUI, private Ui::formSound
{
    Q_OBJECT
    
    public:
        SoundUI(Sigmod::Sound* sound, QWidget* parent);
        ~SoundUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varName_textChanged(const QString& name);
        void on_buttonBrowse_clicked();
        
        void stateChanged(Phonon::State newState, Phonon::State /*oldState*/);
        void resetAudioData();
        void tick(qint64 time);
    private slots:
        void initGui();
        void refreshGui();
        void setGui();
    private:
        Phonon::AudioOutput* m_output;
        Phonon::MediaObject* m_media;
        QBuffer* m_buffer;
};
}

#endif
