/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_SPECIESABILITYUI
#define SIGMODR_SPECIESABILITYUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_speciesability.h"

// Forward declarations
namespace Sigmod
{
class SpeciesAbility;
}

namespace Sigmodr
{
class SpeciesAbilityUI : public ObjectUI, private Ui::formSpeciesAbility
{
    Q_OBJECT
    
    public:
        SpeciesAbilityUI(Sigmod::SpeciesAbility* ability, QWidget* parent);
        ~SpeciesAbilityUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varAbility_activated(const int ability);
        void on_varWeight_valueChanged(const int weight);
    private slots:
        void refreshGui();
        void setGui();
};
}

#endif
