/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_SPECIESMOVEUI
#define SIGMODR_SPECIESMOVEUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_speciesmove.h"

// Forward declarations
namespace Sigmod
{
class SpeciesMove;
}

namespace Sigmodr
{
class SpeciesMoveUI : public ObjectUI, private Ui::formSpeciesMove
{
    Q_OBJECT
    
    public:
        SpeciesMoveUI(Sigmod::SpeciesMove* move, QWidget* parent);
        ~SpeciesMoveUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varMove_activated(const int move);
        void on_varLevel_valueChanged(const int level);
        void on_varWildLevel_valueChanged(const int wildLevel);
    private slots:
        void refreshGui();
        void setGui();
};
}

#endif
