/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_TRAINERUI
#define SIGMODR_TRAINERUI

// Sigmodr includes
#include "ObjectUI.h"

// Form include
#include "ui_trainer.h"

// Forward declarations
namespace Sigmod
{
class Trainer;
}

namespace Sigmodr
{
class TrainerUI : public ObjectUI, private Ui::formTrainer
{
    Q_OBJECT
    
    public:
        TrainerUI(Sigmod::Trainer* trainer, QWidget* parent);
        ~TrainerUI();
    public slots:
        void apply();
        void discard();
    protected slots:
        void on_varName_textChanged(const QString& name);
        void on_varMoneyFactor_valueChanged(const int moneyFactor);
        void on_varSkin_currentIndexChanged(const int skin);
        void on_varDepth_valueChanged(const int depth);
        void on_varTeamIntel_activated(const int teamIntel);
        void on_varMoveIntel_activated(const int moveIntel);
        void on_varItemIntel_activated(const int itemIntel);
        void on_varAbilityIntel_activated(const int abilityIntel);
        void on_varStatIntel_activated(const int statIntel);
    private slots:
        void initGui();
        void refreshGui();
        void setGui();
};
}

#endif
