/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "RootModel.h"

// Model includes
#include "SigmodModel.h"

// Sigmod includes
#include "../../sigmod/Sigmod.h"

Sigmodr::RootModel::RootModel() :
        GroupModel(NULL, NULL)
{
}

Sigmodr::RootModel::~RootModel()
{
}

bool Sigmodr::RootModel::setData(const QVariant& /*value*/, int /*role = Qt::EditRole*/)
{
    return false;
}

void Sigmodr::RootModel::addSigmod(Sigmod::Sigmod* sigmod)
{
    addChild(new SigmodModel(this, sigmod));
}

void Sigmodr::RootModel::deleteSigmod(const Sigmod::Sigmod* sigmod)
{
    for (int i = 0; i < m_objects.size(); ++i)
    {
        if (m_objects[i]->object() == sigmod)
        {
            delete m_objects[i];
            m_objects.removeAt(i);
            emit(childRowChanged(i));
            break;
        }
    }
}

QString Sigmodr::RootModel::types() const
{
    return "Sigmod";
}

void Sigmodr::RootModel::addObject(Sigmod::Object* /*object*/)
{
}

void Sigmodr::RootModel::deleteObject(BaseModel* /*model*/)
{
}
