/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_ROOTMODEL
#define SIGMODR_ROOTMODEL

// Model includes
#include "GroupModel.h"
#include "SigmodModel.h"

namespace Sigmodr
{
// Forward declarations
class SigmodModel;

class RootModel : public GroupModel
{
    Q_OBJECT
    
    public:
        RootModel();
        ~RootModel();
        
        bool setData(const QVariant& /*value*/, int /*role = Qt::EditRole*/);
        
        void addSigmod(Sigmod::Sigmod* sigmod);
        void deleteSigmod(const Sigmod::Sigmod* sigmod);
        
        QString types() const;
    public slots:
        void addObject(Sigmod::Object* /*object = NULL*/);
        void deleteObject(BaseModel* /*model*/);
};
}

#endif
