/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_SPECIESMODEL
#define SIGMODR_SPECIESMODEL

// Model includes
#include "GroupObjectModel.h"

// Forward declarations
namespace Sigmod
{
class Species;
}

namespace Sigmodr
{
class SpeciesModel : public GroupObjectModel
{
    Q_OBJECT
    
    public:
        SpeciesModel(BaseModel* parent, Sigmod::Species* species);
        ~SpeciesModel();
        
        QVariant data(int role = Qt::DisplayRole) const;
        
        bool setData(const QVariant& value, int role = Qt::EditRole);
        
        QString types() const;
    public slots:
        void addObject(Sigmod::Object* /*object = NULL*/);
        void deleteObject(BaseModel* /*model*/);
        
        void deleteSelf();
    protected:
        void setupData();
};
}

#endif
