/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODR_STATUSMODEL
#define SIGMODR_STATUSMODEL

// Model includes
#include "ObjectModel.h"

// Forward declarations
namespace Sigmod
{
class Status;
}

namespace Sigmodr
{
class StatusModel : public ObjectModel
{
    Q_OBJECT
    
    public:
        StatusModel(BaseModel* parent, Sigmod::Status* status);
        ~StatusModel();
        
        QVariant data(int role = Qt::DisplayRole) const;
    public slots:
        void deleteSelf();
};
}

#endif
