/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGSCRIPT_SPECIESITEMWRAPPER
#define SIGSCRIPT_SPECIESITEMWRAPPER

// Sigscript includes
#include "ObjectWrapper.h"

// Sigmod includes
#include "../sigmod/SpeciesItem.h"

namespace Sigscript
{
// Forward declarations
class ItemWrapper;
class SpeciesWrapper;

class SIGSCRIPT_EXPORT SpeciesItemWrapper : public ObjectWrapper
{
    Q_OBJECT
    
    public:
        static SpeciesItemWrapper* create(const Sigmod::SpeciesItem* item, SpeciesWrapper* parent);
        
        Q_SCRIPTABLE ItemWrapper* item();
        Q_SCRIPTABLE int weight() const;
    private:
        SpeciesItemWrapper(const Sigmod::SpeciesItem* item, SpeciesWrapper* parent);
        SpeciesItemWrapper& operator=(const SpeciesItemWrapper& rhs);
        
        const Sigmod::SpeciesItem* m_item;
};
}
Q_DECLARE_METATYPE(Sigscript::SpeciesItemWrapper*)

#endif
