/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "SpriteWrapper.h"

// Sigscript includes
#include "SigmodWrapper.h"

Sigscript::SpriteWrapper* Sigscript::SpriteWrapper::create(const Sigmod::Sprite* sprite, SigmodWrapper* parent)
{
    if (!m_instances.contains(Signature(parent, sprite->id())))
        m_instances[Signature(parent, sprite->id())] = new SpriteWrapper(sprite, parent);
    return qobject_cast<SpriteWrapper*>(m_instances[Signature(parent, sprite->id())]);
}

Sigscript::SpriteWrapper::SpriteWrapper(const Sigmod::Sprite* sprite, SigmodWrapper* parent) :
        ObjectWrapper(sprite, parent),
        m_sprite(sprite)
{
}

QString Sigscript::SpriteWrapper::name() const
{
    return m_sprite->name();
}

QImage Sigscript::SpriteWrapper::sprite() const
{
    return m_sprite->sprite();
}
