/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "StatusWrapper.h"

// Sigscript includes
#include "SigmodWrapper.h"

Sigscript::StatusWrapper* Sigscript::StatusWrapper::create(const Sigmod::Status* status, SigmodWrapper* parent)
{
    if (!m_instances.contains(Signature(parent, status->id())))
        m_instances[Signature(parent, status->id())] = new StatusWrapper(status, parent);
    return qobject_cast<StatusWrapper*>(m_instances[Signature(parent, status->id())]);
}

Sigscript::StatusWrapper::StatusWrapper(const Sigmod::Status* status, SigmodWrapper* parent) :
        ObjectWrapper(status, parent),
        m_status(status)
{
}

QString Sigscript::StatusWrapper::name() const
{
    return m_status->name();
}

Sigmod::Script Sigscript::StatusWrapper::battleScript() const
{
    return m_status->battleScript();
}

Sigmod::Script Sigscript::StatusWrapper::worldScript() const
{
    return m_status->worldScript();
}
