/*
 * Copyright 2008 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "TimeWrapper.h"

// Sigscript includes
#include "SigmodWrapper.h"

Sigscript::TimeWrapper* Sigscript::TimeWrapper::create(const Sigmod::Time* time, SigmodWrapper* parent)
{
    if (!m_instances.contains(Signature(parent, time->id())))
        m_instances[Signature(parent, time->id())] = new TimeWrapper(time, parent);
    return qobject_cast<TimeWrapper*>(m_instances[Signature(parent, time->id())]);
}

Sigscript::TimeWrapper::TimeWrapper(const Sigmod::Time* time, SigmodWrapper* parent) :
        ObjectWrapper(time, parent),
        m_time(time)
{
}

QString Sigscript::TimeWrapper::TimeWrapper::name() const
{
    return m_time->name();
}

int Sigscript::TimeWrapper::TimeWrapper::hour() const
{
    return m_time->hour();
}

int Sigscript::TimeWrapper::TimeWrapper::minute() const
{
    return m_time->minute();
}
